import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, getControl } from 'handie-vue';
import { StringFilterHeadlessWidget } from 'handie-vue/dist/widgets';
let InputStringFilterWidget = class InputStringFilterWidget extends StringFilterHeadlessWidget {
    render(h) {
        const props = { value: this.value, placeholder: this.getPlaceholder() };
        if (this.config.className) {
            props.className = this.config.className;
        }
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.filter;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
            }
        }
        return h(getControl('TextInput'), { props, on: { input: this.onChange } });
    }
};
InputStringFilterWidget = __decorate([
    Component
], InputStringFilterWidget);
export default InputStringFilterWidget;
